local debugMessages = false
luaDebugMode = false
function onCreatePost()
	setProperty('cameraSpeed', 1)	-- in the real event, "CLASSIC" ignores duration so it's set to 1, sorry about that
end

local charListLol = {"dad", "boyfriend", "gf"}
function onEvent(n, v1, v2)
	if n == "Focus Camera" then
		local char = "dad"
		local charNum = 1
		local x = 0
		local y = 0
		local dur = 4
		local speed = crochet/1000
		local ease = "CLASSIC"

		charNum = stringTrim(stringSplit(v1, ",")[1])
		x = stringTrim(stringSplit(v1, ",")[2])
		y = stringTrim(stringSplit(v1, ",")[3])
		dur = stringTrim(stringSplit(v2, ",")[1])
		ease = stringTrim(stringSplit(v2, ",")[2])

		charNum = charNum:gsub(' ', '')
		charNum = tonumber(charNum)
		char = charListLol[charNum+1]
		x = x:gsub(' ', '')
		y = y:gsub(' ', '')
		dur = dur:gsub(' ', '')
		ease = ease:gsub(' ', '')
		dur = tonumber(dur)
		if dur > 0 then
			local kiloMult = 4/dur
			speed = crochet/(1000*kiloMult)
		else
			ease = "INSTANT" -- just set the ease to instant and don't bother
		end
		if ease == "CLASSIC" or ease == "INSTANT" then else
			if stringEndsWith(ease, "In") or stringEndsWith(ease, "Out") then else
				debugPrint("CAMERA FOCUS EVENT ERROR: EASE HAS AN INVALID PREFIX! ", "FF0000")
			end
		end

		cancelTimer("cameraWait")
		cancelTween("camMoveX")
		cancelTween("camMoveY")

		if ease == "CLASSIC" then
			setProperty('cameraSpeed', 1)
			setProperty('camFollow.x', getCameraPositions(char)[1] + x)
			setProperty('camFollow.y', getCameraPositions(char)[2] + y)
			if char == "gf" then setProperty('cameraSpeed', 0) end
		elseif ease == "INSTANT" then
			setProperty('cameraSpeed', 300)
			setProperty('camFollow.x', getCameraPositions(char)[1] + x)
			setProperty('camFollow.y', getCameraPositions(char)[2] + y)
			if char == "gf" then setProperty('cameraSpeed', 0) end
		else
			setProperty('cameraSpeed', 300)
			doTweenX('camMoveX', 'camFollow', getCameraPositions(char)[1] + x, speed, ease)
			doTweenY('camMoveY', 'camFollow', getCameraPositions(char)[2] + y, speed, ease)
		end
		callOnLuas("onMoveCamera", {char})

		if debugMessages then
			debugPrint("char: " .. charNum, "FFFF00")
			debugPrint("char: " .. char, "FFFF00")
			debugPrint("x: " .. x, "00FFFF")
			debugPrint("y: " .. y, "00FFFF")
			debugPrint("dur: " .. dur, "FF00FF")
			debugPrint("speed: " .. speed, "FF6666")
			debugPrint("ease: " .. ease, "00FF00")
			debugPrint("CAMERA FOLLOW EVENT:")
			debugPrint("--------------")
		end

	elseif n == "" then
		if v1 == "toggledebug" then
			debugMessages = not debugMessages
			luaDebugMode = not luaDebugMode
		elseif v1 == "printcam" then
			debugPrint("x: " .. getProperty("camFollow.x"))
			debugPrint("y: " .. getProperty("camFollow.y"))
		end
	end
end

function onTweenCompleted(t)
	if t == "camMoveX" then
		setProperty('cameraSpeed', 1)
		--[[if debugMessages then
			debugPrint('lol')
		end]]
	end
end

function getCameraPositions(c)		-- replicate entirely how PlayState gets the camera position LOL
	local a = {150, -100}
	if c == "boyfriend" then
		a = {-100, -100}
	elseif c == "gf" then
		a = {0, 0}
	end
	local b = c
	b:gsub("boyfriend", "boyfriendCameraOffset")
	b:gsub("dad", "opponentCameraOffset")
	b:gsub("gf", "girlfriendCameraOffset")
	b = {getProperty(b .. "[0]"), getProperty(b .. "[1]")}
	if getProperty(b[0]) == nil or getProperty(b[1]) == nil then b = {0, 0} end

	return {getMidpointX(c) + a[1] - getProperty(c .. ".cameraPosition[0]") - b[1],
	getMidpointY(c) + a[2] + getProperty(c .. ".cameraPosition[1]") + b[2]}
end

function stringSplit(str, sep)					-- i gotta be honest i have no fucking clue what these do
    if sep == nil then sep = "%s" end
    local t = {}
    for str in string.gmatch(str, "([^" .. sep .. "]+)") do
        table.insert(t, str)
    end
    return t
end
function stringTrim(s)
    return s:match( "^%s*(.-)%s*$" )
end